//@author: antokhio
//@help: template for standard shaders
//@tags: template
//@credits: 

//StructuredBuffer<float4> color <bool color=true;>;

Texture2D tex0;
SamplerState s0:IMMUTABLE {Filter=MIN_MAG_MIP_LINEAR;AddressU=CLAMP;AddressV=CLAMP;};

float4x4 tW : WORLD;
float4x4 tVP : VIEWPROJECTION;

float4x4 tTex <bool uvspace=true; string uiname="Texture Transform";>;

struct VS_IN
{
	float4 pos : POSITION;
	//float4 uv : TEXCOORD0;
};

struct VS_OUT
{
    float4 pos: POSITION;
    //float4 uv: TEXCOORD0;
};



struct GS_OUT
{
	float4 pos: SV_Position;
    //float4 uv: TEXCOORD0;
	uint rt : SV_RenderTargetArrayIndex;
};

uint rt;

VS_OUT VS(VS_IN input)
{
    VS_OUT output = (VS_OUT)0;
    output.pos  = input.pos;
    //output.uv = mul(input.uv, tTex);
    return output;
}

[maxvertexcount(3)]
void GS (triangle VS_OUT input[3], inout TriangleStream<GS_OUT> gsout)
{
	GS_OUT output;
	[unroll]
	for (int i = 0; i < 3; i++)
	{
		output.pos = mul(input[i].pos,mul(tW,tVP));
		output.rt = rt;
		
		gsout.Append(output);
	}
	gsout.RestartStrip();
	
}

float4 PS(GS_OUT input): SV_Target
{
    float4 col = 1;//tex0.Sample(s0,input.uv.xy);
	
    return col;
}

technique10 Template
{
	pass P0
	{
		SetVertexShader( CompileShader( vs_4_0, VS() ) );
		SetGeometryShader( CompileShader( gs_4_0, GS() ) );
		SetPixelShader( CompileShader( ps_4_0, PS() ) );
	}
}




